package pl.edu.mimuw.xml.lab06;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class DomFormatter {

	/**
	 * Przechodzi podane drzewo DOM i wypisuje proste informacje o niektorych
	 * typach wezlow.
	 * 
	 * @param nd
	 *            wezel, ktorego podrzewo jest wypisywane
	 */
	public static void printDomTree(Node nd) {
		switch (nd.getNodeType()) {
		case Node.DOCUMENT_NODE:
			for (Node cur = nd.getFirstChild(); cur != null; cur = cur.getNextSibling()) {
				printDomTree(cur);
			}
			break;
		case Node.ELEMENT_NODE:
			System.out.println("<" + nd.getNodeName() + ">");
			for (Node cur = nd.getFirstChild(); cur != null; cur = cur.getNextSibling()) {
				printDomTree(cur);
			}
			System.out.println("</" + nd.getNodeName() + ">");
			break;
		case Node.TEXT_NODE:
			String napis = nd.getNodeValue();
			/* obcinam gdyby byl za dlugi */
			if (napis.length() > 100)
				napis = napis.substring(0, 100);
			System.out.println(napis);
			break;
		}
	}

	public static void main(String[] args) {
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document doc = db.parse(args[0]);
			printDomTree(doc);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
