package pl.edu.mimuw.xml.more_sax;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLFilterImpl;

/**
 * This filter removes elements with names starting from 's' and changes the
 * names of all other elements to upper case.
 */
public class UpperCaseFilter extends XMLFilterImpl {
	private boolean pass = true;

	@Override
	public void startElement(String aUri, String aLocalName, String aName,
			Attributes atts) throws SAXException {
		if(aName.startsWith("s")) {
			pass  = false;
		} else {
			pass = true;
		}
		
		if (pass) {
			super.startElement(aUri, aLocalName.toUpperCase(),
					aName.toUpperCase(), atts);
		}
	}

	@Override
	public void endElement(String aUri, String aLocalName, String aName)
			throws SAXException {
		if (pass) {
			super.endElement(aUri, aLocalName.toUpperCase(),
					aName.toUpperCase());
		}
	}
}
