package pl.edu.mimuw.xml.rooms;

import java.io.File;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import pl.edu.mimuw.xml.rooms.jaxb_generated.Room;
import pl.edu.mimuw.xml.rooms.jaxb_generated.Rooms;

public class CountSeats_JAXB {
	private int sum = 0;
	
	public static void main(String[] args) {
		if (args.length < 1) {
			System.out.println("Provide input file name.");
			System.exit(-1);
		}
		try {
			CountSeats_JAXB program = new CountSeats_JAXB();
			int result = program.countSeats(args[0]);
			System.out.println("Result: " + result);
		} catch (Exception e) {
			System.out.println("Exception! " + e.getMessage());
			e.printStackTrace();
		}
	}

	public int countSeats(String fileName) throws JAXBException {
		System.out.println("Starting with file " + fileName);
		JAXBContext jaxbContext = JAXBContext.newInstance(Rooms.class);
		Unmarshaller u = jaxbContext.createUnmarshaller();
		Rooms rooms = (Rooms) u.unmarshal(new File(fileName));
		if(rooms != null)
			this.processRooms(rooms);
		return sum;
	}

	private void processRooms(Rooms rooms) {
		for(Room room : rooms.getRoom()) {
			if(room.getEquipment().isProjector() && room.getSeats() != null) {
				sum += room.getSeats();
			}
		}
	}
}
