package pl.edu.mimuw.xml.rooms;

import java.io.IOException;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

public class CountSeats_SAX_Traditional {
	public static void main(String[] args) {
		if (args.length < 1) {
			System.out.println("Provide input file name.");
			System.exit(-1);
		}
		try {
			CountSeats_SAX_Traditional program = new CountSeats_SAX_Traditional();
			int result = program.countSeats(args[0]);
			System.out.println("Result: " + result);
		} catch (Exception e) {
			System.out.println("Exception! " + e.getMessage());
			e.printStackTrace();
		}
	}

	public int countSeats(String fileName) throws SAXException, IOException  {
		System.out.println("Starting with file " + fileName);
		CSHandler_Traditional handler = new CSHandler_Traditional();
		XMLReader reader = XMLReaderFactory.createXMLReader();
		reader.setContentHandler(handler);
		reader.parse(new InputSource(fileName));
		return handler.getSum();
	}
}
